'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.REWIND_ACTION = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.isGossipType = isGossipType;

var _scuttlebutt = require('scuttlebutt');

var _scuttlebutt2 = _interopRequireDefault(_scuttlebutt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var REWIND_ACTION = exports.REWIND_ACTION = '@@scuttlebutt/REWIND';

function isGossipType(type) {
  return type.substr(0, 1) !== '@';
}

var Dispatcher = function (_Scuttlebutt) {
  _inherits(Dispatcher, _Scuttlebutt);

  function Dispatcher() {
    _classCallCheck(this, Dispatcher);

    // history log of actions and points in time

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Dispatcher).call(this));

    _this._actions = [];

    // dispatch to redux
    _this._reduxDispatch = function (a) {
      return a;
    };
    return _this;
  }

  // wraps the redux dispatch


  _createClass(Dispatcher, [{
    key: 'dispatch',
    value: function dispatch(_dispatch) {
      var _this2 = this;

      this._reduxDispatch = _dispatch;

      return function (action) {
        if (isGossipType(action.type)) {
          _this2.localUpdate(action);
        }
        return _dispatch(action);
      };
    }

    // rewinds history when it changes

  }, {
    key: 'wrapReducer',
    value: function wrapReducer(reducer) {
      var states = [];

      // wrap the root reducer to track history and rewind occasionally
      return function (currentState, action) {
        if (action.type === REWIND_ACTION) {
          // replace the whole state with the previous index provided
          // the index here naturally matches the index in scuttlebutt._actions
          return states[action.payload];
        }

        return states[states.push(reducer(currentState, action)) - 1];
      };
    }

    // Apply update (action) to our store
    // implemented for scuttlebutt class

  }, {
    key: 'applyUpdate',
    value: function applyUpdate(_ref) {
      var _ref2 = _slicedToArray(_ref, 3);

      var action = _ref2[0];
      var timestamp = _ref2[1];
      var source = _ref2[2];

      // we simply log and emit all actions, and ensure their order as we see them.
      // [[id,payload],timestamp,source_id]
      this._actions.push([action, timestamp, source]);

      // check where this update belongs in time
      for (var i = this._actions.length - 1; i >= 0; i--) {
        var _actions$i = _slicedToArray(this._actions[i], 3);

        var thisAction = _actions$i[0];
        var thisTimestamp = _actions$i[1];
        var thisSource = _actions$i[2];

        // if this timestamp belongs here, and we're not at the end of time

        if (thisTimestamp < thisTimestamp && i !== this._actions.length - 1) {
          // older timestamp greater than recent max
          console.warn('temporal shift detected', source, timestamp, '<', thisTimestamp, thisSource);

          // supply the point to rewind to (history index of newerTimestamp)
          this._reduxDispatch({
            type: REWIND_ACTION,
            // go back to this index in the store
            // our _actions should match _states 1:1, for now
            // and we'll reset to the state /before/ i-action was dispatched
            payload: i - 1
          });

          // dispatch all the actions since this point, again
          for (var j = i; j < this._actions.length; j++) {
            // dispatch each following action
            this._reduxDispatch(this._actions[j]);
          }

          break;
        }

        // otherwise, we check all the way back to the start of time. just in case
      }

      // locally dispatch foreign updates
      if (source !== this.id) {
        // unfortunately this loses the important info of source_id and timestamp
        // but we don't want to modify the action itself.
        // maybe they can be added as prefixed non-enumerable properties
        this._reduxDispatch(action);
      }

      // applied successfully
      return true;
    }

    // gossip
    // implemented for scuttlebutt class

  }, {
    key: 'history',
    value: function history(sources) {
      return this._actions.filter(function (update) {
        return (0, _scuttlebutt.filter)(update, sources);
      });
    }

    // apply an update locally
    // we should ensure we don't send objects which will explode JSON.parse here
    // implemented over scuttlebutt class

  }, {
    key: 'localUpdate',
    value: function localUpdate(action) {
      if (process.env.NODE_ENV === 'development') {
        try {
          _get(Object.getPrototypeOf(Dispatcher.prototype), 'localUpdate', this).call(this, action);
        } catch (error) {
          throw new Error('Scuttlebutt couldn\'t dispatch', error);
        }
      } else {
        // try our luck
        _get(Object.getPrototypeOf(Dispatcher.prototype), 'localUpdate', this).call(this, action);
      }
    }

    // super.localUpdate(this._filterUpdate(action))
    // Recurse through the value and attempt to remove unserializable objects.
    // A well-structured app won't be dispatching bad actions like this, so
    // this might become a dev-only check. also, it's not foolproof.

  }, {
    key: '_filterUpdate',
    value: function _filterUpdate(value) {
      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') return value;

      if (value && value.constructor && /(^Synthetic|Event$)/.test(value.constructor.name)) return null;

      var result = {};
      for (var prop in value) {
        result[prop] = this._filterUpdate(value[prop]);
      }
      return result;
    }
  }]);

  return Dispatcher;
}(_scuttlebutt2.default);

exports.default = Dispatcher;